/*



	MAKECRD - Make A Windows Cardfile from a TAB Delimited data file or
	          a fixed format file.
	          


	August 8, 1993 in Brooklyn Park, Minnesota
	
	
	Guaranteed 100% Pure FREEWare.... I know.... I wrote it!!!
	
 	
	
	                                             Enjoy!!!
	                                             
	                                             
	                                             
	                                             
	                                             MJM   ;-)
	                                             ===
	                                             
	                                             
	                                             
	Data File Format:
	
		1-40 or less:   Index Value
		TABCharacter
		Up to 10 fields of 40 characters or less separated by a TABCharacter


    Example:
    
        Smith, John~555-1212~7941 Noname Avenue North~Brooklyn Park, MN 55444
        Jones, Jim~555-1213~3532 NoName Avenue South~Minneapolis, MN 55406
        
        Where ~ is my notation for a TABCharacter (CHR(9))
        


	Running this program:
	
		MAKECRD input.dat
		
			will create INPUT.CRD
			        
        

*/


# define CRLF CHR(13)+CHR(10)
# define MAXINPUTBLOCK 512
# define MAXCARDSIZE 10*40
# define NULL0 CHR(0)
# define TABCHAR CHR(9)


# define LASTNAME  RTRIM(LTRIM(SUBSTR(curr_rec,1,18)))
# define FIRSTNAME RTRIM(LTRIM(STRTRAN(SUBSTR(curr_rec,19,16),"'"," ")))
# define INITIALS  RTRIM(LTRIM(SUBSTR(curr_rec,35,3)))
# define PHONE     RTRIM(LTRIM(SUBSTR(curr_rec,38,9)))
# define LOCATION  RTRIM(LTRIM(SUBSTR(curr_rec,47,33)))


******************************************************************************
PROCEDURE MakeCRD(f,modef)
******************************************************************************


LOCAL vfileset:=""
LOCAL newname:=""
LOCAL loopf:=.T.
LOCAL card
LOCAL x
LOCAL y
LOCAL z
LOCAL indexarray:={}
LOCAL cardarray:={}
LOCAL reccnt:=0
LOCAL sizeofdata
LOCAL CR_Count

PUBLIC Curr_Rec
PUBLIC In_Block
PUBLIC Chars_Left
PUBLIC Curr_Buff
PUBLIC RecordsReadCount

@23,0 SAY ""
IF f==NIL                               && Check for missing parameter
    SayMsg( "Syntax: MAKECRD filename")
    ERRORLEVEL(1)                       && DOS errorlevel
    RETURN                              && Program Exit
ENDIF
IF modef==NIL
	modef:=0
ELSE
	modef:=1
ENDIF

BEGIN SEQUENCE                          && Start of Sequence, BREAK terminates
SET EXACT ON
vfileset:=UPPER(RTRIM(LTRIM(f)))        && Trim away spaces 
SayMsg("Input:  "+vfileset)
Init_GetRec()                           && Initialize Get Record routine
input:=FOPEN(vfileset,0)                && Open Input File
IF FERROR()<>0
	CheckError()                        && Check for Error
ENDIF
Chars_Left:=FSEEK(input,0,2)             && Determine File Size in Characters
totalsize:=Chars_Left                    && Save file size
FSEEK(input,0,0)                        && Position to front of input file
x:=AT(".",vfileset)
IF x>0
	newname:=LEFT(vfileset,x)+"CRD"
ELSE
	newname:=vfileset+".CRD"
ENDIF

SayMsg("Output: "+newname)
output:=FCREATE(newname,0)              && Create an empty output file
IF FERROR()<>0
	CheckError()                        && Check for Error
ENDIF

output_offset:=5                        && Initialize Index Character Count
SayMsg("Reading "+vfileset)
DO WHILE loopf .AND. GetRecord()        && Loop while records are left
	IF LEN(Curr_Rec)<3
		LOOP
	ENDIF
	reccnt++
    @24,70 SAY STR(reccnt,9,0)
    
    IF modef==1
    	IF LEFT(Curr_Rec,1)="#"
    		reccnt--
    		LOOP
    	ENDIF
    	card:=LASTNAME+", "+FIRSTNAME+" "+INITIALS
    ELSE
    	x:=AT(TABCHAR,Curr_Rec)
    	IF x<1 
    		SayMsg("Missing Tab Character in record #" + LTRIM(STR(reccnt,10,0)))
    		QUIT
    	ENDIF
        card:=SUBSTR(Curr_Rec,1,x-1)
    ENDIF
    AADD(indexarray,{card,reccnt})
	output_offset:=output_offset+52      /* size of an index entry */
/*

	Create Data area of cardfile:
	
		Change TAB characters to CRLF 
		Make sure it will fit into a card
	
*/

    IF modef==1
      	card:=LASTNAME+", "+FIRSTNAME+" "+INITIALS+CRLF+PHONE+CRLF+LOCATION+CRLF 
    ELSE
	    card:=""
   		CR_Count:=0
   	 	x:=1
   	 	y:=1
   	 	DO WHILE x<LEN(Curr_Rec)
	    	z:=x
    		x:=AT(TABCHAR,SUBSTR(Curr_Rec,x))
    		IF x>1
    			x:=(z-1)+x
	    		card:=card+MinString(RTRIM(SUBSTR(Curr_Rec,y,x-y)))+CRLF
    			y:=x+1
    			x:=y
	    	ELSE
    			IF .NOT. RTRIM(SUBSTR(Curr_Rec,y))==CRLF
    				IF RIGHT(RTRIM(SUBSTR(Curr_Rec,y)),2)==CRLF
    					card:=card+MinString(RTRIM(SUBSTR(Curr_Rec,y)))
    				ELSE
	    				card:=card+MinString(RTRIM(SUBSTR(Curr_Rec,y)))+CRLF
	    			ENDIF
	    		ENDIF
    			x:=LEN(Curr_Rec)+1 
    		ENDIF 
    		CR_Count++
    		IF CR_Count==11              
    			x:=LEN(Curr_Rec)+1
    		ENDIF
	    ENDDO
	ENDIF
    IF LEN(card)>MAXCARDSIZE         /* Max size of a card */
    	card:=LEFT(card,MAXCARDSIZE)
    ENDIF
/*

	Add card data to array
	
*/
    card:=NULL0 + NULL0 + I2BIN(LEN(card)) + card

    AADD(cardarray,card)
/*
	Check for early exit
*/
    IF INKEY()=27                       && Check for ESC key press
        SayMsg("Terminated by User")
        FCLOSE(input)
        FCLOSE(output)
        FERASE(newname)
        loopf:=.F.                      && Exit the program
    ENDIF
    If reccnt==1260
    	SayMsg("CardFile limit of 1,260 cards reached.")
    	Curr_Buff:=""
    	Chars_Left:=0
    ENDIF
ENDDO
/*

	Now generate the CARDFILE CRD format file

*/
IF loopf
    FCLOSE(input)                       && Close input data file
	@24,70 SAY SPACE(9)
	SayMsg("Processing "+LTRIM(STR(reccnt,10,0))+" cards")

/*
	Sort in order by the Index Key
*/
	SayMsg("Starting sort...")
	ASORT(indexarray,,,{|x,y|x[1]<y[1]})
	SayMsg("Ending sort")

	FWRITE(output,"MGC" + I2BIN(reccnt))
	IF FERROR()<>0
		CheckError()
	ENDIF

    SayMsg("Writing Index")
	FOR x=1 TO LEN(indexarray)
		FWRITE(output,NULL0+NULL0+NULL0+NULL0+NULL0+NULL0+ ;
		    L2BIN(output_offset)+  ; 
		    NULL0+ ;
		    LEFT(indexarray[x,1]+REPLICATE(NULL0,40),40)+NULL0)
		IF FERROR()<>0
			CheckError()
		ENDIF
		@24,70 SAY STR(x,9,0)
		sizeofdata:=LEN(cardarray[indexarray[x,2]])
		output_offset:=output_offset+sizeofdata
	NEXT		
	@24,70 SAY SPACE(9)

	SayMsg("Writing Card Data")
	FOR X=1 TO LEN(indexarray)
		FWRITE(output,cardarray[indexarray[x,2]])
		IF FERROR()<>0
			CheckError()
		ENDIF
		@24,70 SAY STR(x,9,0)
	NEXT

    @24,70 SAY SPACE(9)
    FCLOSE(output)                      && Close output data file
    SayMsg(newname+" Ready")
ENDIF

END SEQUENCE                            && Exit point for BREAK command
RETURN                                  && Exit the program.

FUNCTION MinString(s)
LOCAL m
IF LEN(s)>40
	m:=LEFT(s,40)
ELSE
	m:=s
ENDIF
RETURN m

******************************************************************************
FUNCTION CheckError                     && Check for File/DOS errors
errorv:=FERROR()                        && Abort if an error has occurred.
IF errorv<>0
     IF errorv==2
         SayMsg("Missing input file")
     ELSE
         SayMsg("File Error: "+ALLTRIM(STR(errorv)))
     ENDIF
     ERRORLEVEL(errorv)
     BREAK
ENDIF
errorv:=DOSERROR()
IF errorv<>0
     SayMsg( "DOS Error: "+ALLTRIM(STR(errorv)))
     ERRORLEVEL(errorv)
     BREAK
ENDIF
RETURN .F.

******************************************************************************
*
*
* Get an Input Transaction Record
*    A Carriage Return signifies end of record.
*    A Carriage Return must be found at least once
*    every "MAXINPUTBLOCK" characters.
*
*    Chars_Left is number of characters not yet read.
*    Curr_Rec variable returns record with CRLF on the end.
*    Curr_Buff variable contains remainder of In_Block read
*
FUNCTION GetRecord                    && Handle Variable Length Records
LOCAL s:=0
LOCAL pos:=0
LOCAL size:=0
IF Chars_Left<=0 .AND. LEN(Curr_Buff)=0
    RETURN .F.                                 && Return False
ENDIF
pos:=AT(CHR(13),Curr_Buff)             && Find a carriage return
IF pos==0 .OR. pos==LEN(Curr_Buff)
    size:=MAXINPUTBLOCK                        && Size of data In_Block to be read
    IF Chars_Left<MAXINPUTBLOCK
        size:=Chars_Left			       && Last part of file.
    ENDIF
    In_Block:=SPACE(size)             && Make sure In_Block is big enough
    s:=FREAD(input,@In_Block,size)
    IF FERROR()<>0
	    CheckError()
	ENDIF
    Chars_Left:=Chars_Left-size        && Adjust Chars_Left
    Curr_Buff:=Curr_Buff+In_Block && Append new In_Block to Curr_Buff
    pos:=AT(CHR(13),Curr_Buff)         && Find CR
    IF pos==0                                  && If not found
        IF Chars_Left>0
            SayMsg("Carriage Return Not Found in In_Block")
            SayMsg("Program Terminated")
            BREAK
        ELSEIF LEN(Curr_Buff)>0        && Still some Curr_Buff characters?
            Curr_Rec:=Curr_Buff
            Curr_Buff:=""
            RecordsReadCount++                 && Increment record counter
            RETURN .T.
        ELSE
            RETURN .F.                         && No more records left (EOF)
        ENDIF
    ENDIF
ENDIF
Curr_Rec:=LEFT(Curr_Buff,pos+1)  && Extract current record including CRLF
RecordsReadCount++                               && Increment record counter
Curr_Buff:=SUBSTR(Curr_Buff,pos+2)     && Chars_Left - unused bytes
IF LEFT(Curr_Buff,1)==CHR(26)         && CTRL-Z == EOF
	Curr_Buff:=""
	Chars_Left:=0
ENDIF
pos:=AT(CHR(26),Curr_Rec)       && CTRL-Z == EOF
If pos>0
	Curr_Rec:=LEFT(Curr_Rec,pos-1)
	Curr_Buff:=""
	Chars_Left:=0
ENDIF
RETURN .T.                   

******************************************************************************
*-Initializes Global Variables needed by GetRecord function
*
FUNCTION Init_GetRec
Curr_Rec:=SPACE(MAXINPUTBLOCK)
In_Block:=SPACE(MAXINPUTBLOCK)
Chars_Left:=0
Curr_Buff:=""                          && Start with empty Curr_Rec.
RecordsReadCount:=0
RETURN .T.

******************************************************************************
FUNCTION SayMsg(s)
?TIME()+" " + s
RETURN
******************************************************************************
